<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Form per ricercare record in un file sequenziale con PHP</title>
<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
<meta name="generator" content="PSPad editor, www.pspad.com" />
<!-- questa versione dello script presenta l'inconveniente di visualizzare
     la testata della tabella contenente i dati anche se la ricerca ha esito
     negativo. L'inconveniente  stato risolto con lo script
     ricerca_fileseq_confunzione.php -->

<style type="text/css">
body {font-family:'comic sans ms',verdana, 'Times New Roman';
     text-align:center;background-color:#efefea;}
form {width: 600px;
      text-align:left;}              /* altrimenti tutti gli elementi
                                         risulterebbero centrati*/
form fieldset {margin: 0 auto;width:90%;height:150px; border : 1px solid  #000;
               background-color:#fc6;font-size:20px;}
form fieldset legend{font-size:20px;color:#009;}
form label {float:left; width: 250px; text-align: right;margin-right:20px;
            font-size:16px;}
#messaggio {color : #c00;width:90%; font-weight:bold; font-size:20px;
            margin-top:50px;}
</style>

<script Language="JavaScript" Type="text/javascript">
<!--
/* la funzione nascondi() serve per nascondere il div contenente i
   messaggi. Viene richiamata dall'evento onfocus associato
   alla prima casella di testo del form e dall'evento onclick associato
   al pulsante Annulla. In questo esempio serve a nascondere la
   visualizzazione della tabella contenente il risultato della ricerca
   quando si vuole effettuarne un'altra.
*/
function nascondi()
{
   document.getElementById("messaggio").style.display="none";
   document.getElementById("tabella").style.display="none";
}

//-->
</script>
</head>
<body>
<div align="center">
  <br /><br />
  <form  id="form" name="form"  action ="#" method="post">
    <fieldset>
      <legend>Ricerca record in un file sequenziale</legend>
      <br />
        <label for="txtCognome">Inserire il cognome da ricercare</label>
         <input type="text" id="txtCognome" name="txtCognome"
                  value=""  maxlength="20" size="25"
                  onfocus = "javascript:nascondi()" /><br /><br />
         <div align="center">
           <input type="submit" value="Invia" />
           <input type="reset"  value= "Annulla"
                   onclick = "javascript:nascondi()" />
           <input type="button" value="Indietro" "
                    onclick="location.href='homefile.html';" />
         </div>
         <br /><br />
    </fieldset>
  </form>
</div>

<?php
error_reporting(0);         // disabilita la visualizzazione degli errori

/*
Se, nel file "php.ini" la caratteristica "track_errors"  abilitata, qualsiasi
messaggio di errore generato dall'espressione sar salvato nella
variabile globale $php_errormsg. Se lo script  pubblicato presso un
provider  ovvio che l'abilitazione o meno della caratteristica
"track_errors" dipende dal provider e, quindi, vengono visualizzati solo
i messaggi preparati nello script.
*/
if($_POST)
{
   $nomefile = "rubricas.txt";      // nome del file

   /* struttura del record "rubricas.txt"  :
     cognome,nome,via,citta,telefono         */

//la funzione trim elimina gli spazi iniziali e finali in una stringa

  $cognomeric=trim($_POST['txtCognome']);

  $msg='';
  if ($cognomeric=='')
    {
        $msg="Inserire il cognome da ricercare !";
    }
  else
    {

     /* apertura del file in sola lettura  posizionando il puntatore
        all'inizio del file. Se il file non esiste viene segnalato un errore. */

      $f = fopen($nomefile, "r");    // se il file  stato aperto con successo

      if($f)
       {
         ?>
         <div id="tabella">
         <?php
         // Preparazione della tabella per accogliere i dati
          echo "
          <html>
          <body>
          <br />
          <font face=\"comic sans ms\">
          <table align=\"center\" border=\"1\" width=\"80%\" summary=\"rubrica\">
          <caption>
               <font size =\"4\">Visualizzazione record nel file con il
                     dato introdotto</font>
          </caption>
          <!-- intestazione prima riga della tabella -->
          <tr height=\"50\" bgcolor=\"#ffff00\">
              <th>Cognome</th>
              <th>Nome</th>
              <th>Indirizzo</th>
              <th>Residenza</th>
              <th>Telefono</th>
           </tr>
          ";
          ?>
          </div>
          <?php

          $record = fgets($f);             // si legge il primo record
          $flag=0;                         /* verifica la presenza di record
                                              con il dato introdotto */
          while (!feof ($f))               // controllo fine file
          {
             $rubrica = explode("\t",$record);
             $cognome = $rubrica [0];

            /* La funzione strcmp() serve a confrontare due stringhe.
               Restituisce un valore positivo quando la stringa passata come
               primo parametro  pi grande rispetto al secondo e un valore
               negativo quando  pi piccolo. Se entrambe le stringhe sono
               uguali, strcmp() restituisce 0.
               La funzione strcasecmp(), che funziona come strcmp(), pu essere
               utilizzata quando non  necessario fare una distinzione
               tra lettere maiuscole o minuscole. */

             if (strcmp($cognome, $cognomeric)==0)
                {
                  $flag=1;        // almeno un record  stato trovato
              /*  opportuno abblencare tutte le variabili. Nelle variabili
                 corrispondenti a campi non obbligatori  non viene, altrimenti,
                 visualizzata la cella della tabella corrispondente
                 alla variabile vuota */

                    $a1='';
                    $a2='';
                    $a3='';
                    $a4='';

                    $a1 = $rubrica [1];
                    $a2 = $rubrica [2];
                    $a3 = $rubrica [3];
                    $a4 = $rubrica [4];

                    ?>
                      <tr>
                      <td><?php echo ($cognome);?></td>
                      <td><?php echo ($a1);?></td>
                      <td><?php echo ($a2);?></td>
                      <td><?php echo ($a3);?></td>
                      <td><?php echo ($a4);?></td>
                    <?php
                  }

             $record = fgets($f);    // si legge il record successivo

          }     // fine while

            if ($flag == 0)      // si controlla se esiste almeno un record
              {
                $msg="Non esiste alcun record nel file con il dato introdotto!";
              }
            else
              {
                 echo "</table>";
              }
             // chiusura del file
             fclose($f);
       }
      else   // errore nell'apertura del file
       {
            $msg="Errore durante l'apertura del file ".$nomefile;
       }
     } // chiusura dell' if ($cognomeric=='')
   // visualizzazione messaggi
   ?>
     <div align="center">
       <div id="messaggio"><? echo $msg ?></div>
     </div>
   <?

}   // chiusura $_POST
?>
</body>
</html>